#ifndef MOTOR_CONTROL_H_
#define MOTOR_CONTROL_H_

#include "../peripherals/eeprom.h"

typedef struct position_s {
	
	int16_t  actual[6];		    // hodnota aktulnho natoen robota
	uint16_t desired[6];		// hodnota poadovah natoen robota
	uint8_t  _reached; 			// dosaen poadovan pozice
	uint8_t  _validity;			// informace o registrovan nbn hran pulzu
	coord_u stored;
}position_s;

typedef union pinswap_u{
	uint8_t pinmap[2];
	struct bit_s
	{
		uint8_t b0:1;
		uint8_t b1:1;
		uint8_t b2:1;
		uint8_t b3:1;
		uint8_t b4:1;
		uint8_t b5:1;
		uint8_t b6:1;
		uint8_t b7:1;
		uint8_t b8:1;
		uint8_t b9:1;
		uint8_t b10:1;
		uint8_t b11:1;
		uint8_t b12:1;
		uint8_t b13:1;
		uint8_t b14:1;
		uint8_t b15:1;
	}bit;
}pinswap_u;

// prototypy
volatile position_s  *getMCTR_positionStrPtr(void);

void MCTR_init(void);
void test(void);
int otoc_s_motory (void);
void calc_RPM (void);
void stinovani(void);
void print_load (void);
//void print_temp (void);
void tocsmotory (void);
void test_motor (uint8_t kde, uint8_t dir);
void print_position(void);
void referencni(void);

void setrefpoint (void);
void positionNull (void);


#endif /* MOTOR_CONTROL_H_ */