#ifndef EEPROM_H_
#define EEPROM_H_

#include "../controls/safety_system.h"
// poet souadnic uloench v eeprom
#define COUNT_COORDS 50		// nsobeno SIZEOF_COORDS (=7) = velikost zboru pamti v bytech
#define SIZEOF_COORDS 7	
#define SIZEOF_PROG_NAME 10
#define SIZEOF_SIGN 3	
#define SIZEOF_SFTS 4	

// nov typ struktura coord_s
typedef struct coord_s {
	uint16_t A:8;
	uint16_t B:8;
	uint16_t C:10;
	uint16_t D:10;
	uint16_t E:10;
	uint16_t F:10;
} coord_s;

typedef union coord_u{
	uint8_t ee_cord[7];
	coord_s coord;
}coord_u;

typedef struct ee_ctrl_s {
		
	uint8_t   ee_jobticket;
	boolean_t ee_idle;
	boolean_t ee_job;
			
	struct  
	{
		boolean_t ee_prgsaving;
		char	  ee_tmpprgname[SIZEOF_PROG_NAME];
		uint8_t   ee_tmpcntofcord;
		uint8_t   ee_cordidx;
		coord_u   ee_tmpcord;
	}prg;
}ee_ctrl_s;

ee_ctrl_s *getEEPR_eectrlStrPtr(void);

void EEPRM_init (void);
void eeprm_dispatch(void);
void eeprm_read_cord(coord_s *p_coord, uint8_t wherefrom);
void eeprm_write_cord(coord_s *p_coord, uint8_t where);
void get_ee_limits_data(volatile sfts_s *sPtr );
void set_ee_limits_data(volatile sfts_s *sPtr );

#endif /* EEPROM_H_ */