#ifndef UART_H_
#define UART_H_
#include "../config.h"

#ifndef CONFIG_H_
	// --------------------------------------------- //
	//        NASTAVEN SRIOVHO KANLU             //
	//                                               //
	// --- definice pinu UART                        //
	// --------------------------------------------- //
	#define RX_PIN  PIN0	 
	#define TX_PIN  PIN1	  
	#define RX_DDR  DDRE	
	#define TX_DDR  DDRE	
	// --------------------------------------------- //
	// nastaveni serioveho kanalu
	#define TXBUFFLEN 64
	#define RXBUFFLEN 64
	#define USART_BAUDRATE  19200  //  skutench 38461, chyba 0.1588%
	#define BAUD_PRESCALE (((F_CPU / ((USART_BAUDRATE / 2) * 16UL))) - 1)
	// _____________________________________________ //
#endif

boolean_t *getUART_rxLEDptr(void);
boolean_t *getUART_txLEDptr(void);

void UART_init( char ***packet);
void uart_getchar(char *c);
void uart_putchar(char c);
void uart_putstr(const char *s);
void uart_putstr_f(const char *s);
void uart_put_uint8(uint8_t val);
void uart_put_uint16(uint16_t val);
void uart_put_float(float val);
int  uart_printf(char c, FILE *stream);

#endif /* UART_H_ */