﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

namespace eeprm_filler
{
    public partial class eeprm_filler : Form
    {
         bool dataontheway = false;
         string paket;
         bool ee_dataontheway = false;
         bool enable;
         bool dolni = false;

        public eeprm_filler()
        {
            InitializeComponent();
            
            serialPort1.BaudRate = 19200;
            serialPort1.DtrEnable = true;
            connectIco.Visible = false;
            serialPort1.DataReceived += serialPort1_DataReceived;
            
            
            //Form.
            //new Point(1010, 626);
            programGB.Visible = false;
            cmdPanel.Visible = false;
            odeslatPanel.Visible = false;
            nacistPanel.Visible = false;
            moduceniGB.Location = new Point(13, 181);
            programGB.Location = new Point(13, 181);
            nacistPanel.Location = new Point(12,5);
            odeslatPanel.Location = new Point(12, 5);
            cmdPanel.Location = new Point(12, 5);
            obecPanel.Location = new Point(12, 5);
        }

        public string hex2Bin(string strHex, int bit)
        {
            int decNumber = hex2Dec(strHex);
            return dec2Bin(decNumber).PadLeft(bit, '0');
        }
        

        public string dec2Bin(int val, int bit)
        {
            return Convert.ToString(val, 2).PadLeft(bit, '0');
        }

        public string hex2Bin(string strHex)
        {
            int decNumber = hex2Dec(strHex);
            return dec2Bin(decNumber);
        }
        public string bin2Hex(string strBin)
        {
            int decNumber = bin2Dec(strBin);
            return dec2Hex(decNumber).PadLeft(2, '0');
        }

        private string dec2Hex(int val)
        {
            return Convert.ToString(val, 16).PadLeft(2, '0'); ;
        }

        private int hex2Dec(string strHex)
        {
            return Convert.ToInt16(strHex, 16);
        }
        private string dec2Bin(int val)
        {
            return Convert.ToString(val, 2);
        }
        public int bin2Dec(string strBin)
        {
            return Convert.ToInt16(strBin, 2);
        }

        public static byte[] StrToByteArray(string str)
        {
            System.Text.UTF8Encoding encoding = new System.Text.UTF8Encoding();
            return encoding.GetBytes(str);
        }


        private void dalsisouradnici()
        {

            
            if(prglistBox.Items.Count > 0)
            {
                byte[] hexbyte = new byte[11];

                hexbyte[0] = Convert.ToByte('_');
                hexbyte[1] = Convert.ToByte(11);
                hexbyte[10] = Convert.ToByte('!');
                
                string rozlusti =  prglistBox.Items[0].ToString();
                hexbyte[2] = Convert.ToByte(Convert.ToInt16(rozlusti.Substring(0, 2)));
                
                string[] binStr = new string[6];
                binStr[0] = dec2Bin(Convert.ToInt16(rozlusti.Substring(3,3)), 8);
                binStr[1] = dec2Bin(Convert.ToInt16(rozlusti.Substring(7,3)), 8);
                binStr[2] = dec2Bin(Convert.ToInt16(rozlusti.Substring(11,4)), 10);
                binStr[3] = dec2Bin(Convert.ToInt16(rozlusti.Substring(16,4)), 10);
                binStr[4] = dec2Bin(Convert.ToInt16(rozlusti.Substring(21,4)), 10);
                binStr[5] = dec2Bin(Convert.ToInt16(rozlusti.Substring(26,4)), 10);

                string binSum;
                binSum = String.Format(binStr[0] + binStr[1] + binStr[2] + binStr[3] + binStr[4] + binStr[5]);

                int j = 0;
                int[] decInt = new int[7];

                for (int i = 0; i < 7; i++)
                {
                    decInt[i] = bin2Dec(binSum.Substring(j, 8));
                    hexbyte[i + 3] = Convert.ToByte(decInt[i]);
                    j += 8;
                }

                if (serialPort1.IsOpen)
                {
                    serialPort1.Write(hexbyte, 0, 11);
                    sendCordsLabel.Text = (Convert.ToInt16(rozlusti.Substring(0, 2)) + 1).ToString(); 
                    sended1PBar.Value = Convert.ToInt16(rozlusti.Substring(0, 2))+1;
                    prglistBox.Items.RemoveAt(0);
                }
            }
            
        }


        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            try
            {
                //string line = serialPort1.ReadLine();
                string existing = serialPort1.ReadExisting();
                
                this.BeginInvoke(new existingBytesHandler(existingBytesRecieved), existing);
                //this.BeginInvoke(new checkEvent(Check), line);
                //this.BeginInvoke(new progresBarsEvent(progres), line);
            }
            catch (Exception)
            {

                statusLabel.Text = "Chyba v příjmu";
            }
        }

        private delegate void existingBytesHandler(string existingByte);

        private void existingBytesRecieved(string existingByte)
        {
            try
            {
                if (dataontheway)
                {
                    int n_end = existingByte.IndexOf("!");
                    if (n_end != -1)
                    {
                        paket += existingByte.Substring(0, n_end+1);
                        testbox.Items.Add(paket);
                        this.BeginInvoke(new paketDispatcherHandler(paketDispatcher), paket);
                        dataontheway = false;
                        paket = null;

                    }
                    else
                    {
                        paket += existingByte;
                    }
                }
                else
                {
                    int n_start = existingByte.IndexOf("_");
                    if (n_start != -1)
                    {
                        paket = existingByte.Substring(n_start, existingByte.Length);
                        int n_end = existingByte.IndexOf("!");
                        if (n_end != -1)
                        {
                            paket = paket.Substring(0, n_end+1);
                            testbox.Items.Add(paket);
                            this.BeginInvoke(new paketDispatcherHandler(paketDispatcher), paket);
                        
                        }
                        else
                        {
                            dataontheway = true;
                        }
                    }
                }
            }
            
            catch (Exception)
            {
                statusLabel.Text = "Chyba v prijmu";
            } 

        }

         private delegate void paketDispatcherHandler(string paket);

         private void paketDispatcher(string paket)
         {
             
              byte[] bajty = new byte[12];
              char[] chars = new char[12];
              int[] ints = new int[6];
            
             char y = Convert.ToChar(paket.Substring(1, 1));
             byte x = Convert.ToByte(y);
             switch (x)
             {
                 case 60:
                    

                     for (int i = 0; i < 12; i++)
                     {
                         chars[i]  = Convert.ToChar(paket.Substring(i+2, 1));
                     }

                     for (int i = 0; i < 12; i++)
                     {
                         bajty[i] = Convert.ToByte(chars[i]);
                     }

                     int j = 0;
                     for (int i = 0; i < 6; i++)
                     {  
                        
                        ints[i] = bajty[j] | (bajty[j++] >> 8);
                        j++;
                     }
                     
                     AcL.Text = ints[0].ToString();
                     BcL.Text = ints[1].ToString();
                     CcL.Text = ints[2].ToString();
                     DcL.Text = ints[3].ToString();
                     EcL.Text = ints[4].ToString();
                     FcL.Text = ints[5].ToString();
                        
                 break;

                 case 111:
                
                     chars[0] = Convert.ToChar(paket.Substring(2, 1));
                     chars[1] = Convert.ToChar(paket.Substring(3, 1));
                     bajty[0] = Convert.ToByte(chars[0]);
                     bajty[1] = Convert.ToByte(chars[1]);
                     ints[0] = bajty[0] | (bajty[1] >> 8);
                     tempL.Text = ints[0].ToString();
                     break;
                 
                 //case "_PRGWR!" :
                 //    timer1.Start();
                 //break;

                 //case "_CORDWR!":
                 //timer1.Start();
                 //break;
    
             }
         }

        private void connectButton_Click(object sender, EventArgs e)
        {
            if (!serialPort1.IsOpen)
            {
                try
                {
                    serialPort1.Open();

                    if (serialPort1.IsOpen)
                    {
                        statusLabel.Text = "Port je nyní připojen...";
                        this.connectButton.Image = ((System.Drawing.Image)(Properties.Resources.dconico));
                        connectIco.Visible = true;
                        dconnectIco.Visible = false;
                    }
                }
                catch (Exception)
                {
                    statusLabel.Text = "Zvolený port nelze otevřít (" + serialPort1.PortName + ")...";
                }
            }
            else
            {
                try
                {
                    serialPort1.Close();

                    if (!serialPort1.IsOpen)
                    {
                        statusLabel.Text = "Port byl uzavřen...";
                        this.connectButton.Image = ((System.Drawing.Image)(Properties.Resources.conico));
                        connectIco.Visible = false;
                        dconnectIco.Visible = true;
                    }
                }
                catch (Exception)
                {
                    statusLabel.Text = "Zvolený port nelze uzavřít (" + serialPort1.PortName + ")...";
                }
            }
        }

        private void eeprm_filler_FormClosing(object sender, FormClosingEventArgs e)
        {
            try
            {
                /* Zavreme spojeni */
                serialPort1.Close();

                /* Do status baru vypiseme soucasny stav */
                if (!serialPort1.IsOpen)
                {
                    statusLabel.Text = "Disconnected...";

                }
            }
            catch (Exception)
            {
                /* V pripade nezdaru vypiseme chybove hlaseni */
                statusLabel.Text = "Při odpojování došlo k chybě "
                      + serialPort1.PortName + " port ...";
            }
        }

        private void openprgButton_Click(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "txt files (*.txt)|*.txt";//|All files (*.*)|*.*";
            openFileDialog1.InitialDirectory = "H:";
            openFileDialog1.Title = "Vyberte program";
                
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                openprgButton.Image = ((System.Drawing.Image)(Properties.Resources.opendocico));
                System.IO.StreamReader programText = new
                System.IO.StreamReader(openFileDialog1.FileName);

                prgwayLabel.Text = openFileDialog1.FileName;
                
                while (!programText.EndOfStream)
                {
                    prglistBox.Items.Add(programText.ReadLine());
                }
                programText.Close();
            }

            tcntCordsLabel.Text = (prglistBox.Items.Count-1).ToString();
            sended1PBar.Maximum = (prglistBox.Items.Count -1); 
        }


        private void button1_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
            {
                serialPort1.Write(textBox1.Text);
                statusLabel.Text = "Written";

            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            dalsisouradnici();
            timer1.Stop();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            dalsisouradnici();
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            this.Cursor = new Cursor(Cursor.Current.Handle);
            
            nacistPanel.Location = panel5.PointToClient(new Point(Cursor.Position.X-15, Cursor.Position.Y-15));
        }

        private void panel2_DoubleClick(object sender, EventArgs e)
        {
            //if (enable)
            //{
            //    timer2.Stop();
            //    enable = false;
            //}
            //else
            //{
            //    timer2.Start();
            //    enable = true;
            //}
        }

        private void pictureBox4_MouseDown(object sender, MouseEventArgs e)
        {
            timer2.Start();
        }

        private void pictureBox4_MouseUp(object sender, MouseEventArgs e)
        {
            timer2.Stop();
        }

        private void prg2mcuButton_Click(object sender, EventArgs e)
        {
            byte[] hexbyte = new byte[14];

            hexbyte[0] = Convert.ToByte('_');
            hexbyte[1] = Convert.ToByte(10);
            hexbyte[13] = Convert.ToByte('!');

            string rozlusti =  prglistBox.Items[0].ToString();

            int ctn = rozlusti.IndexOf(".");
            string prgName = rozlusti.Substring(0, ctn);
            ctn = Convert.ToInt16(rozlusti.Substring(ctn+1));

            prgNameLabel.Text = prgName;
            prgName = prgName.PadRight(10, ' ');
            char[] chars = prgName.ToCharArray();

            for (int i = 0; i < 10; i++)
            {
                hexbyte[i + 2] = Convert.ToByte(chars[i]);
            }
            hexbyte[12] = Convert.ToByte(ctn);

            if (serialPort1.IsOpen)
            {
                serialPort1.Write(hexbyte, 0, 14);
                prglistBox.Items.RemoveAt(0);
                statusLabel.Text = String.Format("Program byl zaznamenán");

            }
        }

        private void teachButton_Click(object sender, EventArgs e)
        {
            byte[] hexbyte = new byte[4];
            hexbyte[0] = Convert.ToByte('_');
            hexbyte[1] = Convert.ToByte(210);
            hexbyte[2] = (byte)Convert.ToInt16(odeslanoCL.Text);
            hexbyte[3] = Convert.ToByte('!');



            if (serialPort1.IsOpen)
            {
                serialPort1.Write(hexbyte, 0, 4);
                odeslanoCL.Text = (Convert.ToInt16(odeslanoCL.Text) + 1).ToString();
            }
        }

        private void mA_trB_MouseUp(object sender, MouseEventArgs e)
        {
            mAvL.Text = mA_trB.Value.ToString();
            
            byte[] hexbyte = new byte[5];
            hexbyte[0] = Convert.ToByte('_');
            hexbyte[1] = Convert.ToByte(201);
            hexbyte[2] = (byte)mA_trB.Value;
            hexbyte[3] = Convert.ToByte('!');

            if (serialPort1.IsOpen)
            {
                serialPort1.Write(hexbyte, 0, 4);
            }
        }

        private void mB_trB_MouseUp(object sender, MouseEventArgs e)
        {
            mBvL.Text = mB_trB.Value.ToString();

            byte[] hexbyte = new byte[5];
            hexbyte[0] = Convert.ToByte('_');
            hexbyte[1] = Convert.ToByte(202);
            hexbyte[2] = (byte)mB_trB.Value;
            hexbyte[3] = Convert.ToByte('!');

            if (serialPort1.IsOpen)
            {
                serialPort1.Write(hexbyte, 0, 4);
            }

        }

        private void mC_trB_MouseUp(object sender, MouseEventArgs e)
        {
            mCvL.Text = mC_trB.Value.ToString();

            byte[] hexbyte = new byte[5];
            hexbyte[0] = Convert.ToByte('_');
            hexbyte[1] = Convert.ToByte(203);
            hexbyte[2] = (byte)mC_trB.Value;
            hexbyte[3] = (byte)(mC_trB.Value >> 8);
            hexbyte[4] = Convert.ToByte('!');

            if (serialPort1.IsOpen)
            {
                serialPort1.Write(hexbyte, 0, 5);
            }

        }

        private void mD_trB_MouseUp(object sender, MouseEventArgs e)
        {
            mDvL.Text = mD_trB.Value.ToString();

            byte[] hexbyte = new byte[5];
            hexbyte[0] = Convert.ToByte('_');
            hexbyte[1] = Convert.ToByte(204);
            hexbyte[2] = (byte) mD_trB.Value;
            hexbyte[3] = (byte)(mD_trB.Value >> 8);
            hexbyte[4] = Convert.ToByte('!');

            if (serialPort1.IsOpen)
            {
                serialPort1.Write(hexbyte, 0, 5);
            }

        }

        private void mE_trB_MouseUp(object sender, MouseEventArgs e)
        {
            mEvL.Text = mE_trB.Value.ToString();

            byte[] hexbyte = new byte[5];
            hexbyte[0] = Convert.ToByte('_');
            hexbyte[1] = Convert.ToByte(205);
            hexbyte[2] = (byte)mE_trB.Value;
            hexbyte[3] = (byte)(mE_trB.Value >> 8);
            hexbyte[4] = Convert.ToByte('!');

            if (serialPort1.IsOpen)
            {
                serialPort1.Write(hexbyte, 0, 5);
            }

        }

        private void mF_trB_MouseUp(object sender, MouseEventArgs e)
        {
            mFvL.Text = mF_trB.Value.ToString();

            byte[] hexbyte = new byte[5];
            hexbyte[0] = Convert.ToByte('_');
            hexbyte[1] = Convert.ToByte(206);
            hexbyte[2] = (byte)mF_trB.Value;
            hexbyte[3] = (byte)(mF_trB.Value >> 8);
            hexbyte[4] = Convert.ToByte('!');

            if (serialPort1.IsOpen)
            {
                serialPort1.Write(hexbyte, 0, 5);
            }
        }

  
        private void button2_Click_2(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
            {
                serialPort1.Write("_f!");
            }
        }

        private void button7_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
            {
                serialPort1.Write("_e!");
            }
        }

        private void button8_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
            {
                serialPort1.Write("_d!");
            }
        }

          private void getCoordB_Click(object sender, EventArgs e)
        {
            byte[] hexbyte = new byte[3];
            hexbyte[0] = Convert.ToByte('_');
            hexbyte[1] = Convert.ToByte(60);
            hexbyte[2] = Convert.ToByte('!');

            if (serialPort1.IsOpen)
            {
                serialPort1.Write(hexbyte, 0, 3);
            }
        }

        private void ručníOvládáníToolStripMenuItem_Click(object sender, EventArgs e)
        {
            byte[] hexbyte = new byte[3];
            hexbyte[0] = Convert.ToByte('_');
            hexbyte[1] = Convert.ToByte(104);
            hexbyte[2] = Convert.ToByte('!');

            if (serialPort1.IsOpen)
            {
                serialPort1.Write(hexbyte, 0, 3);
            }
            cmdPanel.Visible = false;
            odeslatPanel.Visible = false;
            nacistPanel.Visible = false;
            obecPanel.Visible = true;
            moduceniGB.Visible = true;
            programGB.Visible = false;
        }

  
        private void automatickéToolStripMenuItem_Click(object sender, EventArgs e)
        {
            byte[] hexbyte = new byte[3];
            hexbyte[0] = Convert.ToByte('_');
            hexbyte[1] = Convert.ToByte(103);
            hexbyte[2] = Convert.ToByte('!');

            if (serialPort1.IsOpen)
            {
                serialPort1.Write(hexbyte, 0, 3);
            }

            cmdPanel.Visible = false;
            odeslatPanel.Visible = false;
            nacistPanel.Visible = false;
            obecPanel.Visible = true;
            moduceniGB.Visible = false;
            programGB.Visible = true;
        }

        private void načístProgramToolStripMenuItem_Click(object sender, EventArgs e)
        {
            cmdPanel.Visible = false;
            odeslatPanel.Visible = false;
            nacistPanel.Visible = true;
            obecPanel.Visible = false;
        }

        private void odeslatProgramToolStripMenuItem_Click(object sender, EventArgs e)
        {
            cmdPanel.Visible = false;
            odeslatPanel.Visible = true;
            nacistPanel.Visible = false;
            obecPanel.Visible = false;
        }

        private void commandlineToolStripMenuItem_Click(object sender, EventArgs e)
        {
            cmdPanel.Visible = true;
            odeslatPanel.Visible = false;
            nacistPanel.Visible = false;
            obecPanel.Visible = false;
        }

        private void připojitOdpojitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!serialPort1.IsOpen)
            {
                try
                {
                    serialPort1.Open();

                    if (serialPort1.IsOpen)
                    {
                        statusLabel.Text = "Port je nyní připojen...";
                        this.connectButton.Image = ((System.Drawing.Image)(Properties.Resources.dconico));
                        connectIco.Visible = true;
                        dconnectIco.Visible = false;
                    }
                }
                catch (Exception)
                {
                    statusLabel.Text = "Zvolený port nelze otevřít (" + serialPort1.PortName + ")...";
                }
            }
            else
            {
                try
                {
                    serialPort1.Close();

                    if (!serialPort1.IsOpen)
                    {
                        statusLabel.Text = "Port byl uzavřen...";
                        this.connectButton.Image = ((System.Drawing.Image)(Properties.Resources.conico));
                        connectIco.Visible = false;
                        dconnectIco.Visible = true;
                    }
                }
                catch (Exception)
                {
                    statusLabel.Text = "Zvolený port nelze uzavřít (" + serialPort1.PortName + ")...";
                }
            }
        }

        private void eeprm_filler_Load(object sender, EventArgs e)
        {
            string[] ports = SerialPort.GetPortNames();

            foreach (string port in ports)
            {
                portToolStripMenuItem.Items.Add(port);
            }
        }

        private void portToolStripMenuItem_SelectedIndexChanged(object sender, EventArgs e)
        {
            serialPort1.PortName = portToolStripMenuItem.Text;
        }

        private void nahrajprogramB_Click(object sender, EventArgs e)
        {
            openFileDialog1.Filter = "txt files (*.txt)|*.txt";//|All files (*.*)|*.*";
            openFileDialog1.InitialDirectory = "H:";
            openFileDialog1.Title = "Vyberte program";

            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                openprgButton.Image = ((System.Drawing.Image)(Properties.Resources.opendocico));
                System.IO.StreamReader programText = new
                System.IO.StreamReader(openFileDialog1.FileName);

                

                while (!programText.EndOfStream)
                {
                    listBox2.Items.Add(programText.ReadLine());
                }
                programText.Close();
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {

        }



      
        //private void panel2_MouseDown(object sender, MouseEventArgs e)
        //{
        //    this.Cursor = new Cursor(Cursor.Current.Handle);
        //    panel2.Location = new Point(Cursor.Position.X, Cursor.Position.Y);
        //}

  
  

    }
}
